//****************************************************************
// modifying History:
//    15th,Oct.1997 -- includes the Solaris_i86 and linux machine to 
//                     port list
//    3rd,Jan./1998 -- include "stop" functionality control
//    7th,Jan./1998 -- port numbers are for testing account(bye) version
//                  -- difference: 1000 + demo port#  (VDCE account)
//*****************************************************************

import java.io.*;
import java.net.*;


// *****************************************************************
//  URL connection to client machines
// *****************************************************************

   public class URL_client {

        int local_port = 0 ;
        String DB_driver[] = null ;
        int DVM_port = 0 ;
        String mach_arch = null ;
        String mach_os = null ;
        String IP = null ;
        String server_name = null ;
        int port = 0 ;
        String user_ID,app_ID = null ;
        String task_id = null;
        int no = 0 ;
        String DB_IP = null;
        String DB_port = null;

     public URL_client(String DB_driver_par[],String IP_par,int DVM_port_par,String mach_arch_par,String mach_os_par,String server_name_par,int port_par,String user_ID_par,String app_ID_par,String task_id_par,int no_par,String DB_IP,String DB_port) {

           DB_driver = DB_driver_par;
           IP = IP_par;
           DVM_port = DVM_port_par;
           mach_arch = mach_arch_par ;
           mach_os = mach_os_par ;
           server_name = server_name_par;
           port = port_par;
           user_ID = user_ID_par;
           app_ID = app_ID_par;
           task_id = task_id_par; 
           no = no_par;
           this.DB_IP = DB_IP;
           this.DB_port = DB_port;
 
       }


    //**** generate port number for clients ******

     public void port_num() {

           int len = IP.length();
           char[] local_IP_ch = IP.toCharArray();

   System.out.println("machine chosen: " + IP );
   switch ( local_IP_ch[len-2] ) {

    case '.' : 
               switch(local_IP_ch[len-1]) { // SOLARIS 
               case '2' : 
                 switch(local_IP_ch[len-4]) {
                  case '9' : local_port = 21008;  break; //ATM
                  case '6' : local_port = 21000;  break; //Ethenet 
                  case '2' : local_port = 41000;  break; 
                              //Solaris-i86:192.124.124.2 
                  default  :
                   System.out.println("\n chosen machine does not in the list! -- 1");
                   System.exit(1); 
                 } //switch
                break;

               case '1' :
                  switch(local_IP_ch[len-4]) {
                  case '9' : local_port = 26104; break; // AIX:-- ATM 
                  case '6' : local_port = 26004; break;// AIX:-- Eth
                  default  :
                   System.out.println("\n chosen machine does not in the list! -- 2");
                   System.exit(1); 
                  } //switch
                 break;

               case '4' :  // Solaris-i86 192.124.124.4
                   local_port = 41001;
                   break;

               case '5' :  //siegfried.top.cis 128.230.25.5
                   local_port = 21025;
                   break;

               case '9' :  // fasolt.top.cis  128.230.25.9
                   local_port = 21029;
                   break;

               default : 
                   System.out.println("\n chosen machine does not in the list! -- 3 ");
                   System.exit(1); 
              }

              break;
 
    case '6' : // AIX's 

              switch(local_IP_ch[len-5]) {

               case '9' : // ATM --
                switch( local_IP_ch[len-1] ) {
                 case '4' : local_port = 26100; break;
                 case '5' : local_port = 26101; break;
                 case '6' : local_port = 26102; break;
                 case '7' : local_port = 26103; break;
                 default  :
                  System.out.println("\n chosen machine does not in the list! -- 4 ");
                  System.exit(1); 
                }  // switch 
                break;

               case '6' : // ethenet --
                switch( local_IP_ch[len-1] ) {
                 case '4' : local_port = 26000; break;
                 case '5' : local_port = 26001; break;
                 case '6' : local_port = 26002; break;
                 case '7' : local_port = 26003; break;
                 default  :
                  System.out.println("\n chosen machine does not in the list! -- 5 ");
                  System.exit(1); 
                } 
                break;

               default  :
                  System.out.println("\n chosen machine does not in the list! -- 6 ");
                  System.exit(1); 

               } //switch

                break;

     case '7' : // SOLARIS  

              switch(local_IP_ch[len-5]) {

               case '9' : // ATM --
                switch( local_IP_ch[len-1] ) {
                case '5' : local_port = 21009; break;
                case '6' : local_port = 21010; break;
                case '7' : local_port = 21011; break;
                default  :
                 System.out.println("\n chosen machine does not in the list! -- 7 ");
                 System.exit(1); 
                } 
                break;

               case '6' : // ethenet --
                switch( local_IP_ch[len-1] ) {
                case '5' : local_port = 21001; break;
                case '6' : local_port = 21002; break;
                case '7' : local_port = 21003; break;
                default  :
                 System.out.println("\n chosen machine does not in the list! -- 8 ");
                 System.exit(1); 
                } 
                break;

               default  :
                 System.out.println("\n chosen machine does not in the list! -- 9 ");
                 System.exit(1); 
             
              }
              break;
     case '3' :  // Linux - ATM lab : 128.230.61.139
              local_port = 31000;
              break;

     case '2' :   // eva.top.cis.syr.edu 128.230.25.25
              local_port = 21045;
              break; 
 
     case '1' :  // top.cis.syr.edu

              switch(local_IP_ch[len-1] ) {
              case '0' : 
                   switch(local_IP_ch[len-4] ) {
                    case '5': local_port = 21030; break;  // top: 128.230.25.10
                    case '4': local_port = 41002; break;  // Solaris_i86 :
                                                          // 192.124.124.10
                    default  :
                      System.out.println("\n chosen machine does not in the list! -- 9 ");
                      System.exit(1); 
                    }
                    break;
            
              case '1' : local_port = 21031; break;
              case '2' : local_port = 21032; break;
              case '3' : local_port = 21033; break;
              case '4' : local_port = 21034; break;
              case '5' : local_port = 21035; break;
              case '9' : local_port = 21039; break;
              default :
                 System.out.println("\n chosen machine does not in the list! --10 ");
                 System.exit(1); 
              } 

              break;

     case '0' : // SOALRIS at LINK 

              switch(local_IP_ch[len-5]) {

               case '9' : // ATM --
                switch(local_IP_ch[len-1] ) {
                 case '1' : local_port = 21004; break;
                 case '2' : local_port = 21005; break;
                 case '3' : local_port = 21006; break;
                 case '4' : local_port = 21007; break;
                 default  :        
                  System.out.println("\n chosen machine does not in the list! -- 11");
                  System.exit(1); 
                 }
                 break;

               case '0' : // ethenet --
                switch(local_IP_ch[len-1] ) {
                 case '1' : local_port = 21012; break;
                 case '2' : local_port = 21013; break;
                 case '3' : local_port = 21014; break;
                 case '4' : local_port = 21015; break;
                 default  :
                  System.out.println("\n chosen machine does not in the list! -- 12 ");
                  System.exit(1); 
                 }
                 break;

               default  :
                  System.out.println("\n chosen machine does not in the list!-- 13");
                  System.exit(1); 
       
               }
               break;

     default : System.out.println("\n chosen machine does not in the list! -- 14");
               System.exit(1); 

     }

   }

   //==================================================
   //     invoke L-CVM through URL 
   //==================================================

   public void connect() {
        URL clientURL = null ;
        URLConnection conJava;
        InputStream rawInput;

            try {
                 String addr = null ;

                Integer DVM_port_Int = new Integer(DVM_port);

                if(mach_arch.startsWith("Sparc") ) {
                 DB_driver[no-1] = "Exist";  // database accessable
                 addr = new String("http://" + IP + ":" + local_port + "/servlet/Client_Servlet3?server_name=" + server_name + "&port=" + port + "&DB_driver='Exist'" + "&user_ID=" + user_ID + "&app_ID=" + app_ID+ "&task_id=" + task_id + "&DVM_port=" + DVM_port_Int + "&DB_IP=" + DB_IP + "&DB_port=" + DB_port);  
                } //if
                else if(mach_arch.startsWith("rs6000") ) {
                 DB_driver[no-1] = "Exist";  // database accessable 
                 addr = new String("http://" + IP + ":" + local_port + "/servlet/Client_Servlet3_AIX?server_name=" + server_name + "&port=" + port + "&DB_driver='Exist'" + "&user_ID=" + user_ID + "&app_ID=" + app_ID + "&task_id=" + task_id +"&DVM_port=" + DVM_port_Int + "&DB_IP=" + DB_IP + "&DB_port=" + DB_port);  
                } //else AIX

                else if(mach_arch.startsWith("x86") ) {
                 DB_driver[no-1] = "Exist";  // database accessable 

                 if(mach_os.startsWith("Solaris") ) {
                 addr = new String("http://" + IP + ":" + local_port + "/servlet/Client_Servlet3_AIX?server_name=" + server_name + "&port=" + port + "&DB_driver='Exist'" + "&user_ID=" + user_ID + "&app_ID=" + app_ID + "&task_id=" + task_id +"&DVM_port=" + DVM_port_Int + "&DB_IP=" + DB_IP + "&DB_port=" + DB_port);  
                 } //else
                 else if(mach_os.startsWith("Linux") ) {
                  addr = new String("http://" + IP + ":" + local_port + "/servlet/Client_Servlet3_AIX?server_name=" + server_name + "&port=" + port + "&DB_driver='Exist'" + "&user_ID=" + user_ID + "&app_ID=" + app_ID + "&task_id=" + task_id +"&DVM_port=" + DVM_port_Int + "&DB_IP=" + DB_IP + "&DB_port=" + DB_port);  
                 } //else

               } //x86

                 clientURL = new URL(addr); 
                 System.out.println("invoke -- " + addr);
            }
            catch(MalformedURLException e ) {
                System.out.println("Unable to retrieve URL. Error : " +e );
            }
 
        // retrieve information from client_servlet 
//        page.add( "<P> Information from client_servlet --- ");
        try {
             conJava = clientURL.openConnection();
             rawInput = conJava.getInputStream();
             DataInputStream DataIn = new DataInputStream(rawInput);
//             int i;
//             for(i=0;i<=3;i++) {
//                String Value = DataIn.readLine();
//                page.add( "<P>" + Value); 
//             }
         } catch(IOException e) {
             System.out.println("an IO error has been raised. Error : " + e);
        }
     
     }  

   //*************************************************************
   // invoke the reset stop_flag_file servlet in client machines
   //*************************************************************

   public void invoke_Stop_reset() {

        URL clientURL = null ;
        URLConnection conJava;
        InputStream rawInput;

            try {
                 String stop_serv = null;

                 stop_serv = new String("http://" + IP + ":" + local_port + "/servlet/reset_servlet?user_ID=" + user_ID + "&app_ID=" + app_ID+ "&task_id=" + task_id);  
                 clientURL = new URL(stop_serv); 
                 System.out.println("invoke -- " + stop_serv);
            }
            catch(MalformedURLException e ) {
                System.out.println("Unable to retrieve URL. Error : " +e );
            }
 
        try {
             conJava = clientURL.openConnection();
             rawInput = conJava.getInputStream();
             DataInputStream DataIn = new DataInputStream(rawInput);
         } catch(IOException e) {
             System.out.println("an IO error has been raised. Error : " + e);
            }
     

   }


  //****** start to put port number and connect to clients ****

   public void work() {

    port_num(); 

    check_stop ch = new check_stop(user_ID,app_ID);
    if(ch.check()==0) invoke_Stop_reset();

    connect();  // connect to client machines
   }


 }

    
